package me.sablednah.legendquest.skills;

import me.sablednah.legendquest.events.CombatHitCheck;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerToggleSneakEvent;

@SkillManifest(
	name = "Stealth", type = SkillType.ACTIVE, author = "SableDnah", version = 1.0D,
	description = "Increased dodge when sneeking, sneek at full speed.", 
	consumes = "", manaCost = 0, levelRequired = 0, skillPoints = 0, 
	buildup = 0, delay = 0, duration = 30000, cooldown = 60000, 
	dblvarnames = {  }, dblvarvalues = {  }, 
	intvarnames = { "dodgemod" }, intvarvalues = { 5 }, 
	strvarnames = { "message" }, strvarvalues = { "Be vewy vewy qwiet" }
)

public class Stealth extends Skill implements Listener {

	public boolean onEnable() {
		return true;
	}

	public void onDisable() { /* nothing to do */
	}

	public CommandResult onCommand(Player p) {
		if (!validSkillUser(p)) {
			return CommandResult.FAIL;
		}

		// load skill options
		SkillDataStore data = this.getPlayerSkillData(p);
		if (data.type==SkillType.PASSIVE) { // does not require command
			return CommandResult.NOTAVAILABLE;
		}
		
		String message = ((String) data.vars.get("message"));
		p.sendMessage(message);

		return CommandResult.SUCCESS;
	}

	@EventHandler
	public void hitCheck(CombatHitCheck event) {
		if (event.getVictim() instanceof Player) {
			Player p = (Player) event.getVictim();
			if (!p.isSneaking()) { return; } 

			if (!validSkillUser(p)) {
				return;
			}

			// load skill options
			SkillDataStore data = this.getPlayerSkillData(p);
			SkillPhase phase = data.checkPhase();

			if (phase.equals(SkillPhase.ACTIVE) || data.type.equals(SkillType.PASSIVE)) {
				event.setDodgeChance(event.getDodgeChance() - ((Integer) data.vars.get("dodgemod")));
			}
		}
	}

	@EventHandler
	public void onPlayerToggleSneak (PlayerToggleSneakEvent event) {
	    Player p = event.getPlayer();
		if (!validSkillUser(p)) {
			return;
		}
		// load skill options
		SkillDataStore data = this.getPlayerSkillData(p);
		SkillPhase phase = data.checkPhase();

		if (phase.equals(SkillPhase.ACTIVE) || data.type.equals(SkillType.PASSIVE)) {
		    if (event.isSneaking()) {
		        //p.setWalkSpeed(0.7F); //Makes the player move considerably faster when sneaking
		    	p.setSneaking(true);
		    	event.setCancelled(true);
		    } else { //If the player stopped sneaking
		        //p.setWalkSpeed(0.2F); //Resets their walk speed to normal speed
		    	p.setSneaking(false);
		    	event.setCancelled(true);
		    }
		}
	}
}
